# E2E-QNN
QTN-VQC: a genuine end-to-end quantum neural network

This package aims at a python (PyTorch+Pennylane) implementation of QTN-VQC: an end-to-end quantum neural network on NISQ device. 

## Preparation 

1. Install Pennylane
'''
pip install pennylane --upgrade
'''

2. Install PyTorch
'''
pip install torch torchvision torchaudio
'''

2. PyTorch based Tensor-Train Network toolkit 
```
git clone https://github.com/uwjunqi/Pytorch-Tensor-Train-Network.git
cd Pytorch-Tensor-Train-Network
python setup.py install
```

## Running the codes on the MNIST dataset

1. Simulating the results of the Dense-TPE-VQC model
'''
python dense-tpe-vqc.py
'''

2. Simulating the results of the TTN-TPE-VQC model
'''
python ttn-tpe-vqc.py
'''
